Hibernate loggs error when creating schema on MySQL due to failing index creation
Description

Errors are like:

ERROR [main] [or.hi.to.hb.SchemaExport:484] - HHH000389: Unsuccessful: create index agentTitleCache
Index on AgentBase (titleCache)
ERROR SchemaExport:485 - Specified key was too long; max key length is 1000 bytes

Related issues:

Related to EDIT - feature request #8464: Make AuthorityBases unique New
Related to EDIT - feature request #9025: allow for creating a new schemain e... Closed
Copied to EDIT - feature request #9086: Throw exception during schema generat... New

Associated revisions

Revision 15bf6961 - 06/09/2020 04:22 PM - Andreas Miiller

fix #9058 fix failing index creation for ordinary MySQL key indexes and remove combined unique key for AuthorityBase

History

#1 - 06/09/2020 11:51 AM - Andreas Miiller

- Description updated

#2 - 06/09/2020 03:59 PM - Andreas Miiller
- Status changed from New to In Progress

- % Done changed from 0 to 40

Strange is that on some systems this is only logged as warning while others do throw an exception. | did not yet find out if/how this can be configured
in MySQL.
Probably it is only a problem on ISAM as InnoDB allows larger indexes if innodb_large_prefix is enabled.

However, the problem can be solved by using a prefix a column prefix key part (
https://dev.mysqgl.com/doc/refman/8.0/en/create-index.html#create-index-column-prefixes).

But the problem is that hibernate in the current version does not support this.

Therefore | created a new IndexExporter (MySqllsamIndexExporter) which extends the StandardindexExporter and which is used by the
MySQL5MyISAMUtf8Dialect.

This seems to solve the problem.
Only open issues are
e adapt the uniqueKey on AuthorityBase accordingly which spans 4 columns and is a uniquekey => done in #8464
e make it possible to activate holdOnError flag in SchemaExport to allow throwing Exceptions if problems occur during SchemaExport, otherwise
Users don't get informed in cretain contexts
¢ (related) create schema ddl for tests
#3 - 06/09/2020 04:20 PM - Andreas Miiller

Some further links:

e https://stackoverflow.com/questions/46156953/how-to-resolve-specified-key-was-too-long-max-key-length-is-255-bytes-in-mysql

#4 - 06/09/2020 10:32 PM - Andreas Miuller
https://dev.mysql.com/doc/refman/8.0/en/create-index.html#create-index-column-prefixes
https://dev.e-taxonomy.eu/redmine/issues/8464
https://stackoverflow.com/questions/46156953/how-to-resolve-specified-key-was-too-long-max-key-length-is-255-bytes-in-mysql

- Related to feature request #8464: Make AuthorityBases unique added

#5 - 06/09/2020 10:51 PM - Andreas Miiller

- Related to feature request #9025: allow for creating a new schema in empty dbs via the remote login dialog added

#6 - 06/09/2020 11:35 PM - Andreas Miiller

- Status changed from In Progress to Resolved

- Assignee changed from Andreas Muiller to Andreas Kohlbecker
- Priority changed from New to Highest

- % Done changed from 40 to 50

#7 - 06/18/2020 05:14 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Andreas Miller

make it possible to activate holdOnError flag in SchemaExport to allow throwing Exceptions if problems occur during SchemaExport, otherwise
Users don't get informed in certain contexts

This seems quite complicated since the SessionFactory is a final class, but you could try something else:

Create a looging appender org.apache.log4j.Appender for the logging framework being in use, currently this is log4j and register this apppender. The
appender will receive the logging event issued via LOG.unsuccessfulCreate( sqgilCommand ); from the logger created as
CorelLogging.messagelogger( SchemaExport.class );. The appender could directly notify the Ul when an according LogginEvent is coming in:

SomeEventBus uiEventBus = getUiEventBus () ;
Logger logger = Logger.getLogger (SchemaExport.class);
logger.addAppender (new AppenderSkeleton () {

@Override
public boolean requiresLayout () {
return false;

}
@Override
public void close() {

// TODO Auto-generated method stub

}

@Override
protected void append(LoggingEvent event) {
if (event.getMessage () .toString () .startsWith ("Unsuccessful: create index")) {

uiEventBus.notify (event.getMessage () .toString());

}

i

#8 - 06/20/2020 08:45 AM - Andreas Miiller

- Copied to feature request #9086: Throw exception during schema generation if an exception occurrs added

#9 - 06/20/2020 08:47 AM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Andreas Kohlbecker

| copied the exception handling to a new ticket #9086.

| think the real issue of this ticket (exceptions are thrown in MySQL schema generation) should be solved. Do you agree?
#10 - 07/02/2020 08:38 AM - Andreas Kohlbecker

- Status changed from Feedback to Closed

- Assignee changed from Andreas Kohlbecker to Andreas Mliller

- % Done changed from 50 to 100
https://dev.e-taxonomy.eu/redmine/issues/9086

yes in deed!
